'use strict';

const upload = require('../../lambda/upload');
const async = require('async');
const CONSTANT = require('../../utils/constants');
const displayUtil = require('../../utils/display-utility');

module.exports = {
    updateLambda: (updateLambdaList, awsProfile, callback) => {
        let uploadSpinner = new displayUtil.Spinner(' Updating Lambda function...');
        uploadSpinner.start();
        async.eachSeries(updateLambdaList, (metaData, asyncCallback) => {
            setTimeout(() => {
                upload.uploadByName(metaData.uri, metaData.sourceDir, awsProfile, (err) => {
                    if (err) {
                        console.error('Updating Failed: ' + metaData.uri);
                        asyncCallback(err);
                    } else {
                        asyncCallback();
                    }
                });
            }, CONSTANT.CONFIGURATION.TIME_INTERVAL_FOR_ASYNC_REQUEST);
        }, (err) => {
            if (err) {
                process.exit(1);
            }
            uploadSpinner.stop();
            callback();
        });
    }
};
